
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[转]用Middleware给ASP.NET Core Web API添加自己的授权验证 / 憋错料</title>

    <meta name="description" content="[转]用Middleware给ASP.NET Core Web API添加自己的授权验证 本文转自:http://www.cnblogs.com/catcher1994/p/6021046.html Web API,是一个能让前后端分离.解放前后端生产力的好东西.不过大部分公司应该都没能做到完全的前后端分离.API的实现方式有很 多,可以用ASP.NET Core.也可以用ASP.NET Web API.ASP.NET MVC.NancyFx等.说到Web API,不同的人有不同的做法,可能前台. 中台和后台各一个api站点,也有可能一个模块一个api站点,也有可能各个系统共用一个a">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">[转]用Middleware给ASP.NET Core Web API添加自己的授权验证</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>本文转自：<a href="http://www.cnblogs.com/catcher1994/p/6021046.html" rel="external nofollow noreferrer">http://www.cnblogs.com/catcher1994/p/6021046.html</a></p>
<p>Web API，是一个能让前后端分离、解放前后端生产力的好东西。不过大部分公司应该都没能做到完全的前后端分离。API的实现方式有很</p>
<p>多，可以用ASP.NET Core、也可以用ASP.NET Web API、ASP.NET MVC、NancyFx等。说到Web API，不同的人有不同的做法，可能前台、</p>
<p>中台和后台各一个api站点，也有可能一个模块一个api站点，也有可能各个系统共用一个api站点，当然这和业务有必然的联系。</p>
<p>　　安全顺其自然的成为Web API关注的重点之一。现在流行的OAuth 2.0是个很不错的东西，不过本文是暂时没有涉及到的，只是按照最最最</p>
<p>原始的思路做的一个授权验证。在之前的MVC中，我们可能是通过过滤器来处理这个身份的验证，在Core中，我自然就是选择Middleware来处</p>
<p>理这个验证。</p>
<p>　　下面开始本文的正题：</p>
<p>　　先编写一个能正常运行的api，不进行任何的权限过滤。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1 using Dapper;
 2 using Microsoft.AspNetCore.Mvc;
 3 using System.Data;
 4 using System.Linq;
 5 using System.Threading.Tasks;
 6 using WebApi.CommandText;
 7 using WebApi.Common;
 8 using Common;
 9
10 namespace WebApi.Controllers
11 {
12     [Route("api/[controller]")]
13     public class BookController : Controller
14     {
15
16         private DapperHelper _helper;
17         public BookController(DapperHelper helper)
18         {
19             this._helper = helper;
20         }
21
22         // GET: api/book
23         [HttpGet]
24         public async Task&lt;IActionResult&gt; Get()
25         {
26             var res = await _helper.QueryAsync(BookCommandText.GetBooks);
27             CommonResult&lt;Book&gt; json = new CommonResult&lt;Book&gt;
28             {
29                 Code = "000",
30                 Message = "ok",
31                 Data = res
32             };
33             return Ok(json);
34         }
35
36         // GET api/book/5
37         [HttpGet("{id}")]
38         public IActionResult Get(int id)
39         {
40             DynamicParameters dp = new DynamicParameters();
41             dp.Add("@Id", id, DbType.Int32, ParameterDirection.Input);
42             var res = _helper.Query&lt;Book&gt;(BookCommandText.GetBookById, dp, null, true, null, CommandType.StoredProcedure).FirstOrDefault();
43             CommonResult&lt;Book&gt; json = new CommonResult&lt;Book&gt;
44             {
45                 Code = "000",
46                 Message = "ok",
47                 Data = res
48             };
49             return Ok(json);
50         }
51
52         // POST api/book
53         [HttpPost]
54         public IActionResult Post([FromForm]PostForm form)
55         {
56             DynamicParameters dp = new DynamicParameters();
57             dp.Add("@Id", form.Id, DbType.Int32, ParameterDirection.Input);
58             var res = _helper.Query&lt;Book&gt;(BookCommandText.GetBookById, dp, null, true, null, CommandType.StoredProcedure).FirstOrDefault();
59             CommonResult&lt;Book&gt; json = new CommonResult&lt;Book&gt;
60             {
61                 Code = "000",
62                 Message = "ok",
63                 Data = res
64             };
65             return Ok(json);
66         }
67
68     }
69
70     public class PostForm
71     {
72         public string Id { get; set; }
73     }
74
75 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　api这边应该没什么好说的，都是一些常规的操作，会MVC的应该都可以懂。主要是根据id获取图书信息的方法(GET和POST)。这是我们后</p>
<p>面进行单元测试的两个主要方法。这样部署得到的一个API站点，是任何一个人都可以访问http://<a href="http://api.yourapidomain.com/" rel="external nofollow noreferrer">yourapidomain.com</a>/api/book 来得到相关</p>
<p>的数据。现在我们要对这个api进行一定的处理，让只有权限的站点才能访问它。</p>
<p>　　下面就是编写自定义的授权验证中间件了。</p>
<p>　　Middleware这个东西大家应该都不会陌生了，OWIN出来的时候就有中间件这样的概念了，这里就不展开说明，在ASP.NET Core中是如何</p>
<p>实现这个中间件的可以参考官方文档 <a href="https://docs.asp.net/en/latest/fundamentals/middleware.html" rel="external nofollow noreferrer">Middleware</a>。</p>
<p>　　我们先定义一个我们要用到的option，ApiAuthorizedOptions</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1 namespace WebApi.Middlewares
 2 {
 3     public class ApiAuthorizedOptions
 4     {
 5         //public string Name { get; set; }
 6
 7         public string EncryptKey { get; set; }
 8
 9         public int ExpiredSecond { get; set; }
10     }
11 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　option内容比较简单，一个是EncryptKey ，用于对我们的请求参数进行签名，另一个是ExpiredSecond ，用于检验我们的请求是否超时。</p>
<p>与之对应的是在appsettings.json中设置的ApiKey节点</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre>1   "ApiKey": {
2     //"username": "123",
3     //"password": "123",
4     "EncryptKey": "@*api#%^@",
5     "ExpiredSecond": "300"
6   }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　有了option，下面就可以编写middleware的内容了</p>
<p>　　我们的api中就实现了get和post的方法，所以这里也就对get和post做了处理，其他http method，有需要的可以自己补充。</p>
<p>　　这里的验证主要是下面的几个方面：</p>
<p>　　1.参数是否被篡改</p>
<p>　　2.请求是否已经过期</p>
<p>　　3.请求的应用是否合法</p>
<p>　　主检查方法：Check</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1          /// &lt;summary&gt;
 2         /// the main check method
 3         /// &lt;/summary&gt;
 4         /// &lt;param name="context"&gt;&lt;/param&gt;
 5         /// &lt;param name="requestInfo"&gt;&lt;/param&gt;
 6         /// &lt;returns&gt;&lt;/returns&gt;
 7         private async Task Check(HttpContext context, RequestInfo requestInfo)
 8         {
 9             string computeSinature = HMACMD5Helper.GetEncryptResult($"{requestInfo.ApplicationId}-{requestInfo.Timestamp}-{requestInfo.Nonce}", _options.EncryptKey);
10             double tmpTimestamp;
11             if (computeSinature.Equals(requestInfo.Sinature) &amp;&amp;
12                 double.TryParse(requestInfo.Timestamp, out tmpTimestamp))
13             {
14                 if (CheckExpiredTime(tmpTimestamp, _options.ExpiredSecond))
15                 {
16                     await ReturnTimeOut(context);
17                 }
18                 else
19                 {
20                     await CheckApplication(context, requestInfo.ApplicationId, requestInfo.ApplicationPassword);
21                 }
22             }
23             else
24             {
25                 await ReturnNoAuthorized(context);
26             }
27         }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　Check方法带了2个参数，一个是当前的httpcontext对象和请求的内容信息，当签名一致，并且时间戳能转化成double时才去校验是否超时</p>
<p>和Applicatioin的相关信息。这里的签名用了比较简单的HMACMD5加密，同样是可以换成SHA等加密来进行这一步的处理，加密的参数和规则是</p>
<p>随便定的，要有一个约定的过程，缺少灵活性(就像跟银行对接那样，银行说你就要这样传参数给我，不这样就不行，只好乖乖从命)。</p>
<p>　　Check方法还用到了下面的4个处理</p>
<p>　　1.子检查方法--超时判断CheckExpiredTime</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1          /// &lt;summary&gt;
 2         /// check the expired time
 3         /// &lt;/summary&gt;
 4         /// &lt;param name="timestamp"&gt;&lt;/param&gt;
 5         /// &lt;param name="expiredSecond"&gt;&lt;/param&gt;
 6         /// &lt;returns&gt;&lt;/returns&gt;
 7         private bool CheckExpiredTime(double timestamp, double expiredSecond)
 8         {
 9             double now_timestamp = (DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds;
10             return (now_timestamp - timestamp) &gt; expiredSecond;
11         }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　这里取了当前时间与1970年1月1日的间隔与请求参数中传过来的时间戳进行比较，是否超过我们在appsettings中设置的那个值，超过就是</p>
<p>超时了，没超过就可以继续下一个步骤。</p>
<p>　　2.子检查方法--应用程序判断CheckApplication</p>
<p>　　应用程序要验证什么呢？我们会给每个应用程序创建一个ID和一个访问api的密码，所以我们要验证这个应用程序的真实身份，是否是那些</p>
<p>有权限的应用程序。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1         /// &lt;summary&gt;
 2         /// check the application
 3         /// &lt;/summary&gt;
 4         /// &lt;param name="context"&gt;&lt;/param&gt;
 5         /// &lt;param name="applicationId"&gt;&lt;/param&gt;
 6         /// &lt;param name="applicationPassword"&gt;&lt;/param&gt;
 7         /// &lt;returns&gt;&lt;/returns&gt;
 8         private async Task CheckApplication(HttpContext context, string applicationId, string applicationPassword)
 9         {
10             var application = GetAllApplications().Where(x =&gt; x.ApplicationId == applicationId).FirstOrDefault();
11             if (application != null)
12             {
13                 if (application.ApplicationPassword != applicationPassword)
14                 {
15                     await ReturnNoAuthorized(context);
16                 }
17             }
18             else
19             {
20                 await ReturnNoAuthorized(context);
21             }
22         }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　先根据请求参数中的应用程序id去找到相应的应用程序，不能找到就说明不是合法的应用程序，能找到再去验证其密码是否正确，最后才确</p>
<p>定其能否取得api中的数据。</p>
<p>　　下面两方法是处理没有授权和超时处理的实现:</p>
<p>　　没有授权的返回方法ReturnNoAuthorized</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1         /// &lt;summary&gt;
 2         /// not authorized request
 3         /// &lt;/summary&gt;
 4         /// &lt;param name="context"&gt;&lt;/param&gt;
 5         /// &lt;returns&gt;&lt;/returns&gt;
 6         private async Task ReturnNoAuthorized(HttpContext context)
 7         {
 8             BaseResponseResult response = new BaseResponseResult
 9             {
10                 Code = "401",
11                 Message = "You are not authorized!"
12             };
13             context.Response.StatusCode = 401;
14             await context.Response.WriteAsync(JsonConvert.SerializeObject(response));
15         }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　这里做的处理是将响应的状态码设置成401(Unauthorized)。</p>
<p>　　超时的返回方法ReturnTimeOut</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1         /// &lt;summary&gt;
 2         /// timeout request
 3         /// &lt;/summary&gt;
 4         /// &lt;param name="context"&gt;&lt;/param&gt;
 5         /// &lt;returns&gt;&lt;/returns&gt;
 6         private async Task ReturnTimeOut(HttpContext context)
 7         {
 8             BaseResponseResult response = new BaseResponseResult
 9             {
10                 Code = "408",
11                 Message = "Time Out!"
12             };
13             context.Response.StatusCode = 408;
14             await context.Response.WriteAsync(JsonConvert.SerializeObject(response));
15         }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　这里做的处理是将响应的状态码设置成408(Time Out)。</p>
<p>　　下面就要处理Http的GET请求和POST请求了。</p>
<p>　　HTTP GET请求的处理方法GetInvoke</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1         /// &lt;summary&gt;
 2         /// http get invoke
 3         /// &lt;/summary&gt;
 4         /// &lt;param name="context"&gt;&lt;/param&gt;
 5         /// &lt;returns&gt;&lt;/returns&gt;
 6         private async Task GetInvoke(HttpContext context)
 7         {
 8             var queryStrings = context.Request.Query;
 9             RequestInfo requestInfo = new RequestInfo
10             {
11                 ApplicationId = queryStrings["applicationId"].ToString(),
12                 ApplicationPassword = queryStrings["applicationPassword"].ToString(),
13                 Timestamp = queryStrings["timestamp"].ToString(),
14                 Nonce = queryStrings["nonce"].ToString(),
15                 Sinature = queryStrings["signature"].ToString()
16             };
17             await Check(context, requestInfo);
18         }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　处理比较简单，将请求的参数赋值给RequestInfo，然后将当前的httpcontext和这个requestinfo交由我们的主检查方法Check去校验</p>
<p>这个请求的合法性。</p>
<p>　　同理，HTTP POST请求的处理方法PostInvoke，也是同样的处理。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1         /// &lt;summary&gt;
 2         /// http post invoke
 3         /// &lt;/summary&gt;
 4         /// &lt;param name="context"&gt;&lt;/param&gt;
 5         /// &lt;returns&gt;&lt;/returns&gt;
 6         private async Task PostInvoke(HttpContext context)
 7         {
 8             var formCollection = context.Request.Form;
 9             RequestInfo requestInfo = new RequestInfo
10             {
11                 ApplicationId = formCollection["applicationId"].ToString(),
12                 ApplicationPassword = formCollection["applicationPassword"].ToString(),
13                 Timestamp = formCollection["timestamp"].ToString(),
14                 Nonce = formCollection["nonce"].ToString(),
15                 Sinature = formCollection["signature"].ToString()
16             };
17             await Check(context, requestInfo);
18         }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　最后是Middleware的构造函数和Invoke方法。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1      　　public ApiAuthorizedMiddleware(RequestDelegate next, IOptions&lt;ApiAuthorizedOptions&gt; options)
 2         {
 3             this._next = next;
 4             this._options = options.Value;
 5         }
 6
 7         public async Task Invoke(HttpContext context)
 8         {
 9             switch (context.Request.Method.ToUpper())
10             {
11                 case "POST":
12                     if (context.Request.HasFormContentType)
13                     {
14                         await PostInvoke(context);
15                     }
16                     else
17                     {
18                         await ReturnNoAuthorized(context);
19                     }
20                     break;
21                 case "GET":
22                     await GetInvoke(context);
23                     break;
24                 default:
25                     await GetInvoke(context);
26                     break;
27             }
28             await _next.Invoke(context);
29         }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　到这里，Middleware是已经编写好了，要在Startup中使用，还要添加一个拓展方法ApiAuthorizedExtensions</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1 using Microsoft.AspNetCore.Builder;
 2 using Microsoft.Extensions.Options;
 3 using System;
 4
 5 namespace WebApi.Middlewares
 6 {
 7     public static class ApiAuthorizedExtensions
 8     {
 9         public static IApplicationBuilder UseApiAuthorized(this IApplicationBuilder builder)
10         {
11             if (builder == null)
12             {
13                 throw new ArgumentNullException(nameof(builder));
14             }
15
16             return builder.UseMiddleware&lt;ApiAuthorizedMiddleware&gt;();
17         }
18
19         public static IApplicationBuilder UseApiAuthorized(this IApplicationBuilder builder, ApiAuthorizedOptions options)
20         {
21             if (builder == null)
22             {
23                 throw new ArgumentNullException(nameof(builder));
24             }
25
26             if (options == null)
27             {
28                 throw new ArgumentNullException(nameof(options));
29             }
30
31             return builder.UseMiddleware&lt;ApiAuthorizedMiddleware&gt;(Options.Create(options));
32         }
33     }
34 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　到这里我们已经可以在Startup的Configure和ConfigureServices方法中配置这个中间件了</p>
<p>　　这里还有一个不一定非要实现的拓展方法ApiAuthorizedServicesExtensions，但我个人还是倾向于实现这个ServicesExtensions。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre> 1 using Microsoft.Extensions.DependencyInjection;
 2 using System;
 3
 4 namespace WebApi.Middlewares
 5 {
 6     public static class ApiAuthorizedServicesExtensions
 7     {
 8
 9         /// &lt;summary&gt;
10         /// Add response compression services.
11         /// &lt;/summary&gt;
12         /// &lt;param name="services"&gt;The &lt;see cref="IServiceCollection"/&gt; for adding services.&lt;/param&gt;
13         /// &lt;returns&gt;&lt;/returns&gt;
14         public static IServiceCollection AddApiAuthorized(this IServiceCollection services)
15         {
16             if (services == null)
17             {
18                 throw new ArgumentNullException(nameof(services));
19             }
20
21             return services;
22         }
23
24         /// &lt;summary&gt;
25         /// Add response compression services and configure the related options.
26         /// &lt;/summary&gt;
27         /// &lt;param name="services"&gt;The &lt;see cref="IServiceCollection"/&gt; for adding services.&lt;/param&gt;
28         /// &lt;param name="configureOptions"&gt;A delegate to configure the &lt;see cref="ResponseCompressionOptions"/&gt;.&lt;/param&gt;
29         /// &lt;returns&gt;&lt;/returns&gt;
30         public static IServiceCollection AddApiAuthorized(this IServiceCollection services, Action&lt;ApiAuthorizedOptions&gt; configureOptions)
31         {
32             if (services == null)
33             {
34                 throw new ArgumentNullException(nameof(services));
35             }
36             if (configureOptions == null)
37             {
38                 throw new ArgumentNullException(nameof(configureOptions));
39             }
40
41             services.Configure(configureOptions);
42             return services;
43         }
44     }
45 }</pre>
<p>ApiAuthorizedServicesExtensions</p>
<p>　　为什么要实现这个拓展方法呢？个人认为</p>
<p>　　Options、Middleware、Extensions、ServicesExtensions这四个是实现一个中间件的标配(除去简单到不行的那些中间件)</p>
<p>　　Options给我们的中间件提供了一些可选的处理，提高了中间件的灵活性；</p>
<p>　　Middleware是我们中间件最最重要的实现；</p>
<p>　　Extensions是我们要在Startup的Configure去表明我们要使用这个中间件；</p>
<p>　　ServicesExtensions是我们要在Startup的ConfigureServices去表明我们把这个中间件添加到容器中。</p>
<p>　　下面是完整的Startup</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1 using Microsoft.AspNetCore.Builder;
 2 using Microsoft.AspNetCore.Hosting;
 3 using Microsoft.Extensions.Configuration;
 4 using Microsoft.Extensions.DependencyInjection;
 5 using Microsoft.Extensions.Logging;
 6 using System;
 7 using WebApi.Common;
 8 using WebApi.Middlewares;
 9
10 namespace WebApi
11 {
12     public class Startup
13     {
14         public Startup(IHostingEnvironment env)
15         {
16             var builder = new ConfigurationBuilder()
17                 .SetBasePath(env.ContentRootPath)
18                 .AddJsonFile("appsettings.json", optional: true, reloadOnChange: true)
19                 .AddJsonFile($"appsettings.{env.EnvironmentName}.json", optional: true);
20
21             if (env.IsEnvironment("Development"))
22             {
23                 // This will push telemetry data through Application Insights pipeline faster, allowing you to view results immediately.
24                 builder.AddApplicationInsightsSettings(developerMode: true);
25             }
26
27             builder.AddEnvironmentVariables();
28             Configuration = builder.Build();
29         }
30
31         public IConfigurationRoot Configuration { get; }
32
33         // This method gets called by the runtime. Use this method to add services to the container
34         public void ConfigureServices(IServiceCollection services)
35         {
36             // Add framework services.
37             services.AddApplicationInsightsTelemetry(Configuration);
38             services.Configure&lt;IISOptions&gt;(options =&gt;
39             {
40
41             });
42
43             services.Configure&lt;DapperOptions&gt;(options =&gt;
44             {
45                 options.ConnectionString = Configuration.GetConnectionString("DapperConnection");
46             });
47
48             //api authorized middleware
49             services.AddApiAuthorized(options =&gt;
50             {
51                 options.EncryptKey = Configuration.GetSection("ApiKey")["EncryptKey"];
52                 options.ExpiredSecond = Convert.ToInt32(Configuration.GetSection("ApiKey")["ExpiredSecond"]);
53             });
54
55
56             services.AddMvc();
57
58             services.AddSingleton&lt;DapperHelper&gt;();
59         }
60
61         // This method gets called by the runtime. Use this method to configure the HTTP request pipeline
62         public void Configure(IApplicationBuilder app, IHostingEnvironment env, ILoggerFactory loggerFactory)
63         {
64
65             loggerFactory.AddConsole(Configuration.GetSection("Logging"));
66             loggerFactory.AddDebug();
67
68             app.UseDapper();
69
70             //api authorized middleware
71             app.UseApiAuthorized();
72
73             app.UseApplicationInsightsRequestTelemetry();
74
75             app.UseApplicationInsightsExceptionTelemetry();
76
77             app.UseMvc();
78         }
79     }
80 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>　　万事具备，只欠测试！！</p>
<p>　　建个类库项目，写个单元测试看看。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1 using Common;
 2 using Newtonsoft.Json;
 3 using System;
 4 using System.Collections.Generic;
 5 using System.Net.Http;
 6 using System.Threading.Tasks;
 7 using Xunit;
 8
 9 namespace WebApiTest
10 {
11     public class BookApiTest
12     {
13         private HttpClient _client;
14         private string applicationId = "1";
15         private string applicationPassword = "123";
16         private string timestamp = (DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds.ToString();
17         private string nonce = new Random().Next(1000, 9999).ToString();
18         private string signature = string.Empty;
19
20         public BookApiTest()
21         {
22             _client = new HttpClient();
23             _client.BaseAddress = new Uri("http://localhost:8091/");
24             _client.DefaultRequestHeaders.Clear();
25             signature = HMACMD5Helper.GetEncryptResult($"{applicationId}-{timestamp}-{nonce}", "@*api#%^@");
26         }
27
28         [Fact]
29         public async Task book_api_get_by_id_should_success()
30         {
31             string queryString = $"applicationId={applicationId}&amp;timestamp={timestamp}&amp;nonce={nonce}&amp;signature={signature}&amp;applicationPassword={applicationPassword}";
32
33             HttpResponseMessage message = await _client.GetAsync($"api/book/4939?{queryString}");
34             var result = JsonConvert.DeserializeObject&lt;CommonResult&lt;Book&gt;&gt;(message.Content.ReadAsStringAsync().Result);
35
36             Assert.Equal("000", result.Code);
37             Assert.Equal(4939, result.Data.Id);
38             Assert.True(message.IsSuccessStatusCode);
39         }
40
41         [Fact]
42         public async Task book_api_get_by_id_should_failure()
43         {
44             string inValidSignature = Guid.NewGuid().ToString();
45             string queryString = $"applicationId={applicationId}&amp;timestamp={timestamp}&amp;nonce={nonce}&amp;signature={inValidSignature}&amp;applicationPassword={applicationPassword}";
46
47             HttpResponseMessage message = await _client.GetAsync($"api/book/4939?{queryString}");
48             var result = JsonConvert.DeserializeObject&lt;CommonResult&lt;Book&gt;&gt;(message.Content.ReadAsStringAsync().Result);
49
50             Assert.Equal("401", result.Code);
51             Assert.Equal(System.Net.HttpStatusCode.Unauthorized, message.StatusCode);
52         }
53
54         [Fact]
55         public async Task book_api_post_by_id_should_success()
56         {
57             var data = new Dictionary&lt;string, string&gt;();
58             data.Add("applicationId", applicationId);
59             data.Add("applicationPassword", applicationPassword);
60             data.Add("timestamp", timestamp);
61             data.Add("nonce", nonce);
62             data.Add("signature", signature);
63             data.Add("Id", "4939");
64             HttpContent ct = new FormUrlEncodedContent(data);
65
66             HttpResponseMessage message = await _client.PostAsync("api/book", ct);
67             var result = JsonConvert.DeserializeObject&lt;CommonResult&lt;Book&gt;&gt;(message.Content.ReadAsStringAsync().Result);
68
69             Assert.Equal("000", result.Code);
70             Assert.Equal(4939, result.Data.Id);
71             Assert.True(message.IsSuccessStatusCode);
72
73         }
74
75         [Fact]
76         public async Task book_api_post_by_id_should_failure()
77         {
78             string inValidSignature = Guid.NewGuid().ToString();
79             var data = new Dictionary&lt;string, string&gt;();
80             data.Add("applicationId", applicationId);
81             data.Add("applicationPassword", applicationPassword);
82             data.Add("timestamp", timestamp);
83             data.Add("nonce", nonce);
84             data.Add("signature", inValidSignature);
85             data.Add("Id", "4939");
86             HttpContent ct = new FormUrlEncodedContent(data);
87
88             HttpResponseMessage message = await _client.PostAsync("api/book", ct);
89             var result = JsonConvert.DeserializeObject&lt;CommonResult&lt;Book&gt;&gt;(message.Content.ReadAsStringAsync().Result);
90
91             Assert.Equal("401", result.Code);
92             Assert.Equal(System.Net.HttpStatusCode.Unauthorized, message.StatusCode);
93         }
94     }
95 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 00:28:01 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/run/" title="run">run</a>, <a href="https://www.biecuoliao.com/tag/wait/" title="wait">wait</a>, <a href="https://www.biecuoliao.com/tag/%e6%b7%bb%e5%8a%a0/" title="添加">添加</a>, <a href="https://www.biecuoliao.com/tag/test/" title="test">test</a>, <a href="https://www.biecuoliao.com/tag/cli/" title="cli">cli</a>, <a href="https://www.biecuoliao.com/tag/sea/" title="sea">sea</a>, <a href="https://www.biecuoliao.com/tag/base/" title="base">base</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%8c%e5%85%a8/" title="完全">完全</a>, <a href="https://www.biecuoliao.com/tag/rnn/" title="rnn">rnn</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>[转]用Middleware给ASP.NET Core Web API添加自己的授权验证的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qaLd53.html" rel="bookmark">用Middleware给ASP&period;NET Core Web API添加自己的授权验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Web API,是一个能让前后端分离.解放前后端生产力的好东西.不过大部分公司应该都没能做到完全的前后端分离.API的实现方式有很 多,可以用ASP.NET Core.也可以用ASP.NET Web API.ASP.NET MVC.NancyFx等.说到Web API,不同的人有不同的做法,可能前台. 中台和后台各一个api站点,也有可能一个模块一个api站点,也有可能各个系统共用一个api站点,当然这和业务有必然的联系. 安全顺其自然的成为Web API关注的重点之一.现在流行的OAuth 2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/D3OE7oM.html" rel="bookmark">asp&period;net core web api token验证和RestSharp访问</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对与asp.net core web api验证,多种方式,本例子的方式采用的是李争的&lt;微软开源跨平台移动开发实践&gt;中的token验证方式. Asp.net core web api项目代码: 首先定义三个Token相关的类,一个Token实体类,一个TokenProvider类,一个TokenProviderOptions类 代码如下: /// &lt;summary&gt; /// Token实体 /// &lt;/summary&gt; public class TokenEntity			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXQYX80.html" rel="bookmark">ASP&period;NET Core Web API Cassandra CRUD 操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在本文中,我们将创建一个简单的 Web API 来实现对一个 “todo” 列表的 CRUD 操作,使用 Apache Cassandra 来存储数据,在这里不会创建 UI ,Web API 的测试将使用 Postman 来完成. ASP.NET Core 是 ASP.NET 的重大的重构,ASP.NET Core 是一个全新的开源和跨平台的框架,用于构建如 Web 应用.物联网(IoT)应用和移动后端应用等连接到互联网的基于云的现代应用程序. ASP.NET Core 已经内置了用 MVC 架			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vQkBX0.html" rel="bookmark">docker中运行ASP&period;NET Core Web API</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在docker中运行ASP.NET Core Web API应用程序 本文是一篇指导快速演练的文章,将介绍在docker中运行一个ASP.NET Core Web API应用程序的基本步骤,在介绍的过程中,也会对docker的使用进行一些简单的描述.对于.NET Core以及docker的基本概念,网上已经有很多文章对其进行介绍了,因此本文不会再详细讲解这些内容.对.NET Core和docker不了解的朋友,建议首先查阅与这些技术相关的文档,然后再阅读本文. 先决条件 要完成本文所介绍的演练任			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02k8wp3.html" rel="bookmark">在docker中运行ASP&period;NET Core Web API应用程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文是一篇指导快速演练的文章,将介绍在docker中运行一个ASP.NET Core Web API应用程序的基本步骤,在介绍的过程中,也会对docker的使用进行一些简单的描述.对于.NET Core以及docker的基本概念,网上已经有很多文章对其进行介绍了,因此本文不会再详细讲解这些内容.对.NET Core和docker不了解的朋友,建议首先查阅与这些技术相关的文档,然后再阅读本文. 先决条件 要完成本文所介绍的演练任务,需要准备以下环境: Visual Studio 2015,或者Vi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rz2ol3.html" rel="bookmark">支持多个版本的ASP&period;NET Core Web API</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基本配置及说明 版本控制有助于及时推出功能,而不会破坏现有系统. 它还可以帮助为选定的客户提供额外的功能. API版本可以通过不同的方式完成,例如在URL中添加版本或通过自定义标头和通过Accept-Header作为查询字符串参数. 在这篇文章中,我们来看看如何支持多版本的ASP.NET Core Web API 创建一个ASP.NET Core Web API应用程序.通过 NuGet 安装此软件包:Microsoft.AspNetCore.Mvc.Versioning,打开Startup.c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ekX9v4.html" rel="bookmark">Docker容器环境下ASP&period;NET Core Web API</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Docker容器环境下ASP.NET Core Web API应用程序的调试 本文主要介绍通过Visual Studio 2015 Tools for Docker – Preview插件,在Docker容器环境下,对ASP.NET Core Web API应用程序进行调试.在自己做实验的过程中也碰到了一些问题,经过一些测试和搜索资料,基本解决了这些问题,本文也会对这些问题进行介绍,以免有相同需求的朋友多走弯路. 插件的下载与安装 至撰写本文为止,Visual Studio 2015 Tools			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02XrvE4.html" rel="bookmark">Gitlab CI 自动部署 asp&period;net core web api 到Docker容器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为什么要写这个? 在一个系统长大的过程中会经历不断重构升级来满足商业的需求,而一个严谨的商业系统需要高效.稳定.可扩展,有时候还不得不考虑成本的问题.我希望能找到比较完整的开源解决方案来解决持续集成.监控报警.以及扩容和高可用性的问题.是学习和探索的过程分享给大家,也欢迎同行的人交流. 先来一个三步曲,我们将完成通过GitLab CI 自动部署 net core web api 到Docker 容器的一个示例.这是第一步,通过此文您将了解如何将net core web api 运行在Docker			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bLNDV4.html" rel="bookmark">使用 Swagger 自动生成 ASP&period;NET Core Web API 的文档、在线帮助测试文档（ASP&period;NET Core Web API 自动生成文档）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于开发人员来说,构建一个消费应用程序时去了解各种各样的 API 是一个巨大的挑战.在你的 Web API 项目中使用 Swagger 的 .NET Core 封装 Swashbuckle 可以帮助你创建良好的文档和帮助页面. Swashbuckle 可以通过修改 Startup.cs 作为一组 NuGet 包方便的加入项目.Swashbuckle 是一个开源项目,为使用 ASP.NET Core MVC 构建的 Web APIs 生成 Swagger 文档.Swagger 是一个机器可读的 R			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/QM6n1WM.html" rel="bookmark" class="title">MySQL监控、性能分析&mdash;&mdash;工具篇</a>
					<div>
						MySQL越来越被更多企业接受,随着企业发展,MySQL存储数据日益膨胀,MySQL的性能分析.监控预警.容量扩展议题越来越多.“工欲善其 事,必先利其器”,那么我们如何在进行MySQL性能分析.监控 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/W0jvKA0.html" rel="bookmark" class="title">php的socket通信</a>
					<div>
						对TCP/IP.UDP.Socket编程这些词你不会很陌生吧?随着网络技术的发展,这些词充斥着我们的耳朵.那么我想问: 1.         什么是TCP/IP.UDP?2.         Sock ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lXxVW0.html" rel="bookmark" class="title">SharePoint 2013 使用 PowerShell 更新用户</a>
					<div>
						在SharePoint开发中,经常会遇到网站部署,然而,当我们从开发环境,部署到正式环境以后,尤其是备份还原,所有用户组的用户,还依然是开发环境的,这时,我们就需要用PowerShell更新一下: P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPNnk13.html" rel="bookmark" class="title">调用百度地图</a>
					<div>
						偶也能做百度地图了,嘻嘻,赞一个,废话不多说,代码敬上: 这个简单的样式:强大了可以自己改的 &lt;style type=&quot;text/css&quot;&gt;    .iw_poi_ti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2OAl3.html" rel="bookmark" class="title">SQL Server 数据库的维护&lpar;三&rpar;&lowbar;&lowbar;事务&lpar;transaction&rpar;和锁</a>
					<div>
						--锁 注:SQL Server中的锁用来控制一个事务与另一个事务并发性.系统会自动为被访问的资源设置或释放锁.如果某个事务以锁定一个资源,而另一个事务要访问该资源,那么SQL Server会根据第一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xR7bB4.html" rel="bookmark" class="title">数组 a&plus;1 &amp;amp&semi;a&plus;1 的区别</a>
					<div>
						1 #include&lt;stdio.h&gt; 2 int main() 3 { 4 int a[10]; 5 printf(&quot;a==%d &amp;a==%d\n&quot;,a,&a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQGXV0.html" rel="bookmark" class="title">ajax 内部值 外部调用不了原因</a>
					<div>
						var id=‘123’; $.ajax({ url:’http://www.xxx.com/ajax', type:'post', dataType: &quot;json&quot;, data: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41B7yPM.html" rel="bookmark" class="title">原码、补码、反码</a>
					<div>
						只讨论整数 原码: 正数:符号位 0,数值位即真值: 负数:符号位1,数值位即真值: [+3] = [0000 0011] [-3 ] = [1000 0011] [-127] = [1111 111 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZrlyG3.html" rel="bookmark" class="title">webpack2引入bootstrap的坑</a>
					<div>
						在webpack官网教程的代码分离-css章节中,给出的例子是这样的. //安装 ExtractTextWebpackPlugin 如下 npm install --save-dev extract- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWL5Dl0.html" rel="bookmark" class="title">shell脚本入门</a>
					<div>
						http://blog.csdn.net/yuguiyang1990/article/details/40400271					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49WodJ0.html" rel="bookmark" class="title">Part 17 Consuming ASP NET Web Service in AngularJS using &dollar;http</a>
					<div>
						Here is what we want to do1. Create an ASP.NET Web service. This web service retrieves the data from ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nq9N23.html" rel="bookmark" class="title">两个随机数实例</a>
					<div>
						/* import java.util.Random; public class random_1{ public static void main(String[] args) { Random r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vzdZg3.html" rel="bookmark" class="title">SDL2&period;0的几何图行绘画</a>
					<div>
						SDL2.0的几何图形绘画 通过SDL_Window.SDL_Renderer.SDL_Texture三者实现了简单的几何图形绘画. 包括了SDL_RenderDrawPoint.SDL_Render ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXvKZa3.html" rel="bookmark" class="title">AngularJS API之&dollar;injector ---- 依赖注入</a>
					<div>
						    阅读目录 推断式注入 标记式注入 内联式注入 $injector常用的方法 样例代码 在AngularJS中也有依赖注入的概念,像spring中的依赖注入,但是又有所不同.Spring中使用构 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KvaLjM.html" rel="bookmark" class="title">hdu 1162 Eddy&amp;&num;39&semi;s picture</a>
					<div>
						最小生成树裸题,没有初始化都能AC,看来测试数据只有一组 #include&lt;iostream&gt; #include&lt;vector&gt; #include&lt;cmath&gt; # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEr6W4.html" rel="bookmark" class="title">Oracle Advanced Pricing White Papers</a>
					<div>
						Oracle Order Management - Version 11.5.10.0 and later Oracle Advanced Pricing - Version 11.5.10 and  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MooVXnM.html" rel="bookmark" class="title">hdu 1754 Ihate it</a>
					<div>
						I Hate It Time Limit:3000MS     Memory Limit:32768KB     64bit IO Format:%I64d &amp; %I64u Submit St ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NQg8J3.html" rel="bookmark" class="title">关于HTTP协议传输与接收数据的相关内容</a>
					<div>
						第一篇: HTTP请求报文和HTTP响应报文 http://www.cnblogs.com/biyeymyhjob/archive/2012/07/28/2612910.html 第二篇: 深入浅出U ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YWPOa4.html" rel="bookmark" class="title">shockt通信</a>
					<div>
						目前为止,我们使用的最多网络协议还是tcp/ip网络.通常来说,我们习惯上称为tcp/ip协议栈.至于协议栈分成几层,有两种说法.一种是五层,一种是七层. 5.应用层    4.传输层    3.网络 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38DOXZ3.html" rel="bookmark" class="title">久违的感冒又来了</a>
					<div>
						哎,昨天晚上失眠,今天早上五点钟从迷迷糊糊中醒来,结果听到对面楼的有人在放录像,声音那个大啊,本来就不好的睡眠被彻底赶跑了,哎,赶跑了!待折磨到闹钟响起,我拖着疲惫的身体赶去上班,一上午,简直是在煎熬 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
